
-- Database for Competitor information
CREATE TABLE IF NOT EXISTS `Competitors` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `EventID` int(10) unsigned NOT NULL,  -- From Events table
  `FName` varchar(32) collate utf8_unicode_ci NOT NULL,
  `LName` varchar(32) collate utf8_unicode_ci NOT NULL,
  `BeltRank` varchar(32) collate utf8_unicode_ci NOT NULL,
  `Age` varchar(10) collate utf8_unicode_ci NOT NULL,
  `Matches` int(10) unsigned NOT NULL,  -- Number of matches this competitor has been involved in
  `Losses` int(10) unsigned NOT NULL,   -- Number of losses (for eliminations)
  `Passes` int(10) unsigned NOT NULL,   -- Number of skips (for odd #s of competitors)
  `Flags` int(10) unsigned NOT NULL,    -- Flags (see Competitor.java)
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- Events (You can have more than one in a database)
CREATE TABLE IF NOT EXISTS `Events` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `Description` text collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- Match details: Who fought who, who won, and when
CREATE TABLE IF NOT EXISTS `Matches` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `EventID` int(10) unsigned NOT NULL,
  `Competitor1` int(10) unsigned NOT NULL,  -- These three are all Competitor indices
  `Competitor2` int(10) unsigned NOT NULL,
  `Winner` int(10) unsigned NOT NULL,
  `Time` timestamp NOT NULL default '0000-00-00 00:00:00' on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

