import javax.swing.*;
import java.awt.event.*;

class RegistrationForm extends JFrame {
    // GUI Components
    private JTextField fFirstName, fLastName, fAge;
    private JComboBox fBeltRank;
    private JButton fAddButton, fSearchButton, fClearButton;
    
    // The Database connection
    private Database fConnection = null;
    
    // These are the Belt Ranks that will appear in the belt rank box
    // They need to be updated with real values, obviously ;)
    private static String[] kBeltRanks = {
        "White", "Green", "Blue", "I'm just guessing here"
    };
    
    public RegistrationForm() {
        if (!acquireConnection())
            System.exit(1);
        
        fFirstName = new JTextField(40);
        fLastName = new JTextField(40);
        fAge = new JTextField(5);
        fBeltRank = new JComboBox(kBeltRanks);
        
        fAddButton = new JButton("Add");
        fSearchButton = new JButton("Search");
        fClearButton = new JButton("Clear");
        
        fAddButton.addActionListener(
            // Action for when the user clicks the "Add" button
            new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    Competitor comp = new Competitor();
                    try {
                        comp.setName(fFirstName.getText(), fLastName.getText());
                        comp.setAge(Integer.parseInt(fAge.getText()));
                        comp.setBeltRank((String)fBeltRank.getSelectedItem());
                    } 
                    catch (Exception e) {
                        new JDialog((JFrame)null, "Error in input");
                    }
                    clearFields();
                }
            }
        );
        
        fClearButton.addActionListener(
            // Clear button -- clear the form and the selected user
            new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    clearFields();
                }
            }
        );
        
        add(fFirstName);
        add(fLastName);
        add(fBeltRank);
        add(fAge);
        add(fAddButton);
        add(fSearchButton);
        add(fClearButton);
    }
    
    private boolean acquireConnection() {
        // For now, ignore the connection stuff
        return true;
    }
    
    private void clearFields() {
        fFirstName.setText("");
        fLastName.setText("");
        fAge.setText("");
        fBeltRank.setSelectedIndex(0);
    }
    
    public static void main(String[] args) {
        RegistrationForm frame = new RegistrationForm();
        frame.setSize(800, 600);
        frame.show();
    }
}
