
import java.awt.*;
import javax.swing.*;
import java.util.Random;
import java.awt.print.*;
import java.awt.event.*;
import java.util.Scanner;

public class Window extends JPanel implements Printable {

    final int width = 800, height = 600;
    String[][] names;
    Color color = Color.blue;
    Random random;

    public Window(String[][] x) {

        names = x;
        random = new Random();

        setBackground(Color.white);
        setPreferredSize(new Dimension(width, height));

    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);

        Font font = new Font("Monospaced", Font.PLAIN, 12);
        FontMetrics fontm = g.getFontMetrics(font);

        int down = 20, olddown = 20, right = 20;
        int deltadown = 40;
        int deltaright = 150;
        int fontHeight = fontm.getHeight();

        for (int i = 0; i < 12; ++i) {
            for (int j = 0; j < 12; j++) {
                if (names[i][j] != null) {
                    if (j % 2 == 0) {
                        color = new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256));
                    }
                    g.setColor(color);
                    g.drawString(names[i][j], right, down);

                    g.setColor(Color.black);

                    if (!(names[i][0] != null && (names[i][1] == null || names[i][1] == null))) {
                        if (names[i][j] != null) {
                            int width = fontm.stringWidth(names[i][j]);

                            g.drawLine(right + width, down - fontHeight / 4, right + deltaright / 2, down - fontHeight / 4);
                        }
                    }
                    if ((j % 2 == 0 && names[i][j + 1] != null) && names[i][j + 1] != null) {
                        g.drawLine(right + deltaright / 2, down - fontHeight / 4, right + deltaright / 2, down + deltadown - fontHeight / 4);
                    }
                }//end if
                down += deltadown;
            }//end for

            down = olddown + deltadown / 2;
            olddown = down;
            deltadown *= 2;

            right += deltaright;
        }//end big for

    }

    public int print(Graphics g, PageFormat pf, int page) throws
            PrinterException {

        if (page > 0) {
            return NO_SUCH_PAGE;
        }

        //translate
        Graphics2D g2d = (Graphics2D) g;
        g2d.translate(pf.getImageableX(), pf.getImageableY());
        //print visible
        printAll(g);

        return PAGE_EXISTS;
    }

    public void p() {
        PrinterJob job = PrinterJob.getPrinterJob();
        job.setPrintable(this);
        boolean ok = job.printDialog();
        if (ok) {
            try {
                job.print();
            } catch (PrinterException ex) {
            }
        }
    }

    public static void main(String args[]) {


        String[][] test1 = new String[12][12];

        test1[0][0] = "hi";
        test1[0][1] = "th";
        test1[0][2] = "hdai";
        test1[0][3] = "tgah";
        test1[0][4] = "hadri";
        test1[0][5] = "thasdfasd";
        test1[0][6] = "hdasdi";
        test1[0][7] = "tgadsh";


//	 test1[0][8]="hi";
        //test1[0][9]="th";
        // test1[0][10]="hdai";
        //test1[0][11]="tgah";

        //test1[0][8]="tdash";
        // test1[0][9]="";

        test1[1][0] = "hdfgi";
        test1[1][1] = "thfds";
        test1[1][2] = "hfgsi";
        test1[1][3] = "thfs";
        // test1[1][4]="sgg";
        // test1[1][5]="gfh";

        test1[2][0] = "hi";
        test1[2][1] = "th";
//	 test1[2][2]="thdf";
//	 test1[2][3]="";

        test1[3][0] = "th";
//	 test1[3][1]="tagah";


//	 test1[4][0]="th";


        Window window = new Window(test1);
        JFrame test = new JFrame("Test");
        test.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        test.add(window);
        test.pack();
        test.setVisible(true);
        JButton printButton = new JButton("");
        //  printButton.addActionListener(new ActionListener));
        //   test.add("Center", printButton);
        Scanner scan;
        scan = new Scanner(System.in);
        System.out.println("Print");
        //	if(scan.next().equals("p")){

        window.p();

    }//end main
}//end class
